{ :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
  :: QuickReport 3.0 for Delphi 3 or newer                   ::
  ::                                                         ::
  :: Example MDI with Custom preview project                 ::
  ::                                                         ::
  :: Copyright (c) 1998 QuSoft AS                            ::
  :: All Rights Reserved                                     ::
  ::                                                         ::
  :: web: http://www.qusoft.no   fax: +47 22 41 74 91        ::
  ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: }
unit mdimain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, qrprntr, quickrpt, qrextra, qrcust, qremp, StdCtrls;

type
  // To have a custom preview be used as the default preview,
  // you first define an interface class.  You will provide two
  // functions for this class, Show, and ShowModal.

  TQRMDIPreviewInterface = class(TQRPreviewInterface)
  public
    function Show(AQRPrinter : TQRPrinter) : TWinControl; override;
    function ShowModal(AQRPrinter : TQRPrinter): TWinControl; override;
  end;

  // You can switch between preview interfaces by either adding code in the
  // Show or ShowModal functions to pick the preview or you can define
  // multiple TQRPreviewInterface classes.

  TQRSimplePreviewInterface = class(TQRPreviewInterface)
  public
    function Show(AQRPrinter : TQRPrinter) : TWinControl; override;
    function ShowModal(AQRPrinter : TQRPrinter): TWinControl; override;
  end;

  TfrmMDIMain = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Report1: TMenuItem;
    Countries1: TMenuItem;
    Closeallpreviews1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    Options1: TMenuItem;
    miPreviewcanPrint: TMenuItem;
    CreateList1: TMenuItem;
    Window1: TMenuItem;
    Tile1: TMenuItem;
    Cascade1: TMenuItem;
    SimplePreview1: TMenuItem;
    LoadaQRPfile1: TMenuItem;
    OpenDialog1: TOpenDialog;
    QRCompositeReport1: TQRCompositeReport;
    miCompositeReport: TMenuItem;
    miEmployeeReport: TMenuItem;
    N2: TMenuItem;
    About1: TMenuItem;
    procedure Countries1Click(Sender: TObject);
    procedure Closeallpreviews1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure miPreviewcanPrintClick(Sender: TObject);
    procedure CreateList1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Tile1Click(Sender: TObject);
    procedure Cascade1Click(Sender: TObject);
    procedure SimplePreview1Click(Sender: TObject);
    procedure LoadaQRPfile1Click(Sender: TObject);
    procedure QRCompositeReport1AddReports(Sender: TObject);
    procedure miCompositeReportClick(Sender: TObject);
    procedure miEmployeeReportClick(Sender: TObject);
    procedure About1Click(Sender: TObject);
  private
    { Private declarations }
    aqrCustomer: TqrCustomer;
    aqrEmployee: TqrEmployee;
  public
    { Public declarations }
  end;

var
  frmMDIMain: TfrmMDIMain;

implementation

uses dm_mdi, prev2_32, prevform, about;

{$R *.DFM}

// Now define the functions for the interface class.

function TQRMDIPreviewInterface.Show(AQRPrinter : TQRPrinter) : TWinControl;
begin
  Result := TfrmNetScapePreview.CreatePreview(Application, AQRPrinter);

  // You can set options for your preview here
  TfrmNetScapePreview(Result).bCanPrint := frmMDIMain.miPreviewcanPrint.Checked;

  TfrmNetScapePreview(Result).Show;
end;

function TQRMDIPreviewInterface.ShowModal(AQRPrinter : TQRPrinter) : TWinControl;
begin
  Result := TfrmNetScapePreview.CreatePreview(Application, AQRPrinter);
  // You can set options for your preview here
  TfrmNetScapePreview(Result).bCanPrint := frmMDIMain.miPreviewcanPrint.Checked;

  TfrmNetScapePreview(Result).ShowModal;
end;

function TQRSimplePreviewInterface.Show(AQRPrinter : TQRPrinter) : TWinControl;
begin
  Result := TPreviewForm.CreatePreview(Application, AQRPrinter);
  TPreviewForm(Result).Show;
end;

function TQRSimplePreviewInterface.ShowModal(AQRPrinter : TQRPrinter) : TWinControl;
begin
  Result := TPreviewForm.CreatePreview(Application, AQRPrinter);
  TPreviewForm(Result).ShowModal;
end;

procedure TfrmMDIMain.Countries1Click(Sender: TObject);
var
  aqrCustomer: TqrCustomer;
begin
  // create the report
  aqrCustomer := TqrCustomer.create(nil);

  // preview the report
  aqrCustomer.Preview;

  // free the report object
  aqrCustomer.Free;

  // Repeated calls to the same Preview will cause an AV because the
  // preview forms do not get a chance to close properly between calls.
  // This is a known issue and should be fixed in the next release.
  // The work around is to call Application.ProcessMessages after each
  // call to Preview.
  application.ProcessMessages;
end;

procedure TfrmMDIMain.Closeallpreviews1Click(Sender: TObject);
var
  nIdx: integer;
begin
  // Here is a simple way to close down all of the open
  // previews

  for nIdx := (Screen.FormCount - 1) downto 0 do
    with Screen.Forms[nIdx] do
      if (ClassName = 'TfrmNetScapePreview') or
         (ClassName = 'TQRStandardPreview') then
        Close;
end;

procedure TfrmMDIMain.FormCreate(Sender: TObject);
begin
  // Calling RegisterPreviewClass with the custom
  // interface makes the custom preview the default
  // preview for all reports.
  RegisterPreviewClass(TQRMDIPreviewInterface);
end;

procedure TfrmMDIMain.miPreviewcanPrintClick(Sender: TObject);
begin
  with miPreviewcanPrint do
    Checked := not Checked;
end;

procedure TfrmMDIMain.CreateList1Click(Sender: TObject);
var
  aReport : TCustomQuickRep;
begin
  // You must set the report object to nil before calling QRCreateList
  areport := nil;

  { Build the report }
  QRCreateList(aReport, Self, dmMDI.tbCustomer, 'Customer Listing', nil);

  aReport.ReportTitle := 'QRCreateList example';

  aReport.Preview;

  { all done, free the objects }
  aReport.Free;
  application.ProcessMessages;
end;

procedure TfrmMDIMain.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TfrmMDIMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  // Before exiting, we close any open preview
  Closeallpreviews1Click(Sender);

  // free any dynamicly created reports
  if aqrCustomer <> nil then
    aqrCustomer.Free;
  if aqrEmployee <> nil then
    aqrEmployee.Free;
end;

procedure TfrmMDIMain.Tile1Click(Sender: TObject);
begin
  Tile;
end;

procedure TfrmMDIMain.Cascade1Click(Sender: TObject);
begin
  Cascade;
end;

procedure TfrmMDIMain.SimplePreview1Click(Sender: TObject);
begin
  with SimplePreview1 do
    Checked := not Checked;

  // Disable the Can Print menu item when the simple
  // preview is used
  miPreviewcanPrint.Enabled := not SimplePreview1.Checked;

  // Call RegisterPreviewClass to specify which preview to
  // use.
  if SimplePreview1.Checked then
    RegisterPreviewClass(TQRSimplePreviewInterface)
  else
    RegisterPreviewClass(TQRMDIPreviewInterface);
end;

procedure TfrmMDIMain.LoadaQRPfile1Click(Sender: TObject);
begin
  with OpenDialog1 do
  begin
    DefaultExt := 'QRP';
    Filter := 'Saved report files (*.qrp)|*.QRP';
    if Execute then
    begin
      with TQRPHandler.Create do
      try
        Filename := OpenDialog1.Filename;
        Preview;
      finally
        Free;
        application.ProcessMessages;
      end;
    end;
  end;
end;

procedure TfrmMDIMain.QRCompositeReport1AddReports(Sender: TObject);
begin
  QRCompositeReport1.Reports.Add(aqrCustomer);
  QRCompositeReport1.Reports.Add(aqrEmployee);
end;

procedure TfrmMDIMain.miCompositeReportClick(Sender: TObject);
begin
  if aqrCustomer = nil then
    aqrCustomer := TqrCustomer.create(nil);
  if aqrEmployee = nil then
    aqrEmployee := TqrEmployee.create(nil);

  QRCompositeReport1.Preview;
  application.ProcessMessages;

//  aqrCustomer.Free;
//  aqrEmployee.Free;
end;

procedure TfrmMDIMain.miEmployeeReportClick(Sender: TObject);
var
  qrEmployee: TqrEmployee;
begin
  // create the report
  qrEmployee := TqrEmployee.create(nil);

  // preview the report
  qrEmployee.Preview;

  // free the report object
  qrEmployee.Free;
  application.ProcessMessages;
end;

procedure TfrmMDIMain.About1Click(Sender: TObject);
begin
  with TfrmAbout.Create(Application) do
  begin
    showmodal;
    Free;
  end;
end;

end.
