{ :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
  :: QuickReport 3.0 for Delphi 3 or newer                   ::
  ::                                                         ::
  :: Example MDI with Custom preview project                 ::
  ::                                                         ::
  :: Copyright (c) 1998 QuSoft AS                            ::
  :: All Rights Reserved                                     ::
  ::                                                         ::
  :: web: http://www.qusoft.no   fax: +47 22 41 74 91        ::
  ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: }
unit qrselect;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, printers;

type
  TfrmSelectPrinter = class(TForm)
    Label1: TLabel;
    cbPrinters: TComboBox;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Printer : TPrinter;
    PrinterIndex: integer;
  end;

var
  frmSelectPrinter: TfrmSelectPrinter;

implementation

{$R *.DFM}

procedure TfrmSelectPrinter.FormDestroy(Sender: TObject);
begin
  // All done, free the printer object
  printer.free;
end;

procedure TfrmSelectPrinter.FormShow(Sender: TObject);
var
  nIdx: integer;
begin
  // create a printer to get the list of printers
  Printer := TPrinter.Create;

  // Now populate the combobox with the list of printer names
  try
    with Printer do
      for nIdx := 0 to Printers.Count - 1 do
        cbPrinters.Items.Add(printers[nIdx]);
  except
    raise;
  end;

  // Set the combo box to the current printer as defined
  // by the caller.  It may not be the default printer
  cbPrinters.ItemIndex := PrinterIndex;
end;

procedure TfrmSelectPrinter.BitBtn3Click(Sender: TObject);
begin
  // reset the printer index back to the default
  Printer.PrinterIndex := -1;
  cbPrinters.ItemIndex := Printer.PrinterIndex;
end;

end.
